diff --git a/samples/virtcca-client/ima_measure.c b/samples/virtcca-client/ima_measure.c
new file mode 100644
index 0000000..5b0be69
--- /dev/null
+++ b/samples/virtcca-client/ima_measure.c
@@ -0,0 +1,414 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include <errno.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <rats-tls/api.h>
+#include <rats-tls/log.h>
+#include <rats-tls/claim.h>
+#include <openssl/sha.h>
+#include <openssl/evp.h>
+#include <ima_measure.h>
+
+/* static int verify_sig; */
+/* static unsigned int no_sigs, unknown_keys, invalid_sigs; */
+
+static u_int8_t zero[SHA_DIGEST_LENGTH];
+static u_int8_t fox[SHA_DIGEST_LENGTH];
+static u_int8_t extend[SHA256_DIGEST_LENGTH];
+
+static int display_digest(u_int8_t * digest, u_int32_t digestlen)
+{
+	int i;
+
+	for (i = 0; i < digestlen; i++) {
+		printf("%02x", (*(digest + i) & 0xff));
+	}
+	return 0;
+}
+
+static int ima_eventdigest_parse(u_int8_t * buffer, u_int32_t buflen)
+{
+	return display_digest(buffer, SHA_DIGEST_LENGTH);
+}
+
+static int ima_eventdigest_ng_parse(u_int8_t * buffer, u_int32_t buflen)
+{
+	char hash_algo[CRYPTO_MAX_ALG_NAME + 1] = { 0 };
+	int algo_len = strlen((char *)buffer) - 1; /* format: algo + ':' + '\0' */
+	const EVP_MD *md;
+	int digest_len;
+
+	if (algo_len > CRYPTO_MAX_ALG_NAME) {
+		printf("Hash algorithm name too long\n");
+		return ERROR_ENTRY_PARSING;
+	}
+
+	printf("%s", buffer);
+
+	memcpy(hash_algo, buffer, algo_len);
+	md = EVP_get_digestbyname(hash_algo);
+	if (md == NULL) {
+		printf("Unknown hash algorithm '%s'\n", hash_algo);
+		return ERROR_ENTRY_PARSING;
+	}
+
+	digest_len = EVP_MD_size(md);
+
+	if (algo_len + 2 + digest_len != buflen) {
+		printf("Field length mismatch, current: %d, expected: %d\n",
+		       algo_len + 2 + digest_len, buflen);
+		return ERROR_ENTRY_PARSING;
+	}
+
+	return display_digest(buffer + algo_len + 2, digest_len);
+}
+
+static int ima_parse_string(u_int8_t * buffer, u_int32_t buflen)
+{
+	char *str;
+
+	/* some callers include the terminating null in the
+ 	 * buflen, others don't (eg. 'd').
+ 	 */
+	str = calloc(buflen + 1, sizeof(u_int8_t));
+	if (str == NULL) {
+		printf("Out of memory\n");
+		return -ENOMEM;
+	}
+
+	memcpy(str, buffer, buflen);
+	printf("%s", str);
+	free(str);
+	return 0;
+}
+
+static int ima_eventname_parse(u_int8_t * buffer, u_int32_t buflen)
+{
+	if (buflen > TCG_EVENT_NAME_LEN_MAX + 1) {
+		printf("Event name too long\n");
+		return -1;
+	}
+
+	return ima_parse_string(buffer, buflen);
+}
+
+static int ima_eventname_ng_parse(u_int8_t * buffer, u_int32_t buflen)
+{
+	return ima_parse_string(buffer, buflen);
+}
+
+static int ima_eventsig_parse(u_int8_t * buffer, u_int32_t buflen)
+{
+	return display_digest(buffer, buflen);
+}
+
+/* IMA template field definition */
+struct ima_template_field {
+	const char field_id[IMA_TEMPLATE_FIELD_ID_MAX_LEN];
+	int (*field_parse) (u_int8_t * buffer, u_int32_t buflen);
+};
+
+/* IMA template descriptor definition */
+struct ima_template_desc {
+	char *name;
+	char *fmt;
+	int num_fields;
+	struct ima_template_field **fields;
+};
+
+static struct ima_template_desc defined_templates[] = {
+	{.name = IMA_TEMPLATE_IMA_NAME, .fmt = IMA_TEMPLATE_IMA_FMT},
+	{.name = "ima-ng",.fmt = "d-ng|n-ng"},
+	{.name = "ima-sig",.fmt = "d-ng|n-ng|sig"},
+};
+
+static struct ima_template_field supported_fields[] = {
+	{.field_id = "d",.field_parse = ima_eventdigest_parse},
+	{.field_id = "n",.field_parse = ima_eventname_parse},
+	{.field_id = "d-ng",.field_parse = ima_eventdigest_ng_parse},
+	{.field_id = "n-ng",.field_parse = ima_eventname_ng_parse},
+	{.field_id = "sig",.field_parse = ima_eventsig_parse},
+};
+
+struct event {
+	struct {
+		u_int32_t pcr;
+		u_int8_t digest[SHA_DIGEST_LENGTH];
+		u_int32_t name_len;
+	} header;
+	char name[TCG_EVENT_NAME_LEN_MAX + 1];
+	struct ima_template_desc *template_desc; /* template descriptor */
+	u_int32_t template_data_len;
+	u_int8_t *template_data;	/* template related data */
+};
+
+static int parse_template_data(struct event *template)
+{
+	int offset = 0, result = 0;
+	int i, j, is_ima_template;
+	char *template_fmt, *template_fmt_ptr, *f;
+	u_int32_t digest_len;
+	u_int8_t *digest;
+
+	is_ima_template = strcmp(template->name, "ima") == 0 ? 1 : 0;
+	template->template_desc = NULL;
+
+	for (i = 0; i < ARRAY_SIZE(defined_templates); i++) {
+		if (strcmp(template->name,
+			defined_templates[i].name) == 0) {
+			template->template_desc = defined_templates + i;
+			break;
+		}
+	}
+
+	if (template->template_desc == NULL) {
+		i = ARRAY_SIZE(defined_templates) - 1;
+		template->template_desc = defined_templates + i;
+		template->template_desc->fmt = template->name;
+	}
+
+	template_fmt = strdup(template->template_desc->fmt);
+	if (template_fmt == NULL) {
+		printf("Out of memory\n");
+		return -ENOMEM;
+	}
+
+	template_fmt_ptr = template_fmt;
+	for (i = 0; (f = strsep(&template_fmt_ptr, "|")) != NULL; i++) {
+		struct ima_template_field *field = NULL;
+		u_int32_t field_len = 0;
+
+		for (j = 0; j < ARRAY_SIZE(supported_fields); j++) {
+			if (!strcmp(f, supported_fields[j].field_id)) {
+				field = supported_fields + j;
+				break;
+			}
+		}
+
+		if (field == NULL) {
+			result = ERROR_FIELD_NOT_FOUND;
+			printf("Field '%s' not supported\n", f);
+			goto out;
+		}
+
+		if (is_ima_template && strcmp(f, "d") == 0)
+			field_len = SHA_DIGEST_LENGTH;
+		else if (is_ima_template && strcmp(f, "n") == 0)
+			field_len = strlen(template->template_data + offset);
+		else {
+			memcpy(&field_len, template->template_data + offset,
+				 sizeof(u_int32_t));
+			offset += sizeof(u_int32_t);
+		}
+		result = field->field_parse(template->template_data + offset,
+					    field_len);
+		if (result) {
+			printf("Parsing of '%s' field failed, result: %d\n",
+			       f, result);
+			goto out;
+		} 
+
+		/* ToDo: add verifiy ima-sig template */
+
+		offset += field_len;
+		printf(" ");
+	}
+out:
+	free(template_fmt);
+	return result;
+}
+
+static int read_template_data(struct event *template, FILE *fp)
+{
+	int len, is_ima_template;
+	int byte_read;
+
+	is_ima_template = strcmp(template->name, "ima") == 0 ? 1 : 0;
+	if (!is_ima_template) {
+		byte_read = fread(&template->template_data_len, sizeof(u_int32_t), 1, fp);
+		len = template->template_data_len;
+	} else {
+		template->template_data_len = SHA_DIGEST_LENGTH +
+		    TCG_EVENT_NAME_LEN_MAX + 1;
+		/*
+		 * Read the digest only as the event name length
+		 * is not known in advance.
+		 */
+		len = SHA_DIGEST_LENGTH;
+	}
+
+	template->template_data = calloc(template->template_data_len,
+					 sizeof(u_int8_t));
+	if (template->template_data == NULL) {
+		printf("ERROR: out of memory\n");
+		return -ENOMEM;
+	}
+
+	byte_read = fread(template->template_data, len, 1, fp);
+	if (is_ima_template) {	/* finish 'ima' template data read */
+		u_int32_t field_len;
+
+		byte_read = fread(&field_len, sizeof(u_int32_t), 1, fp);
+		byte_read = fread(template->template_data + SHA_DIGEST_LENGTH,
+		      field_len, 1, fp);
+	}
+	return 0;
+}
+
+/*
+ * Calculate the sha1 hash of data
+ */
+static void calc_digest(u_int8_t * digest, int len, void *data)
+{
+	SHA_CTX c;
+
+	/* Calc template hash for an ima entry */
+	memset(digest, 0, sizeof(*digest));
+	SHA1_Init(&c);
+	SHA1_Update(&c, data, len);
+	SHA1_Final(digest, &c);
+}
+
+static int verify_template_hash(struct event *template)
+{
+	int rc;
+
+	rc = memcmp(fox, template->header.digest, sizeof(fox));
+	if (rc != 0) {
+		u_int8_t digest[SHA_DIGEST_LENGTH];
+		memset(digest, 0, sizeof(digest));
+		calc_digest(digest, template->template_data_len,
+			    template->template_data);
+		rc = memcmp(digest, template->header.digest, sizeof(digest));
+		if (rc != 0)
+			printf("- %s\n", "failed");
+	}
+	return rc != 0 ? 1 : 0 ;
+}
+
+/*
+ * calculate the SHA1 aggregate-pcr value based on the
+ * IMA runtime binary measurements.
+ *
+ * --validate: forces validation of the aggregrate pcr value
+ * 	     for an invalidated PCR. Replace all entries in the
+ * 	     runtime binary measurement list with 0x00 hash values,
+ * 	     which indicate the PCR was invalidated, either for
+ * 	     "a time of measure, time of use"(ToMToU) error, or a
+ *	     file open for read was already open for write, with
+ * 	     0xFF's hash value, when calculating the aggregate
+ *	     pcr value.
+ *
+ * --verify: for all IMA template entries in the runtime binary
+ * 	     measurement list, calculate the template hash value
+ * 	     and compare it with the actual template hash value.
+ * 	     
+ * 	     For records with a signature, verify the file data
+ * 	     hash against the file signature.
+ *
+ *	     Return the number of incorrect hash measurements
+ *	     and signatures.
+ *
+ * template info:  list #, PCR-register #, template hash, template name
+ *	IMA info:  IMA hash, filename hint
+ *
+ * Ouput: displays the aggregate-pcr value
+ * Return code: if verification enabled, returns number of verification
+ * 		errors.
+ */
+int ima_measure(void *data, size_t datalen, int validate, int verify)
+{
+	int ret;
+	FILE *fp;
+	struct event template;
+	u_int8_t pcr[SHA256_DIGEST_LENGTH];
+	int i, count = 0;
+	int hash_failed = 0;
+	size_t byte_read;
+	
+	fp = fopen(IMA_MEASUREMENTS_PATH, "r");
+	if (!fp) {
+		printf("fn: %s\n", IMA_MEASUREMENTS_PATH);
+		perror("Unable to open file\n");
+		return 1;
+	}
+	memset(pcr, 0, SHA256_DIGEST_LENGTH);	/* initial PCR content 0..0 */
+	memset(zero, 0, SHA_DIGEST_LENGTH);
+	memset(fox, 0xff, SHA_DIGEST_LENGTH);
+
+	printf("### PCR HASH                                  "
+		   "TEMPLATE-NAME\n");
+	while (fread(&template.header, sizeof(template.header), 1, fp)) {
+		SHA256_CTX c;
+
+		/* Extend simulated PCR with new template digest */
+		SHA256_Init(&c);
+		SHA256_Update(&c, pcr, SHA256_DIGEST_LENGTH);
+		if (validate) {
+			if (memcmp(template.header.digest, zero, SHA_DIGEST_LENGTH) == 0)
+				memset(template.header.digest, 0xFF, SHA_DIGEST_LENGTH);
+		}
+		
+		memset(extend, 0, SHA256_DIGEST_LENGTH);
+		memcpy(extend, template.header.digest, SHA_DIGEST_LENGTH);
+
+		SHA256_Update(&c, extend, SHA256_DIGEST_LENGTH);
+		SHA256_Final(pcr, &c);
+
+		OpenSSL_add_all_digests();
+
+		printf("%3d %03u ", count++, template.header.pcr);
+		display_digest(template.header.digest, SHA_DIGEST_LENGTH);
+		if (template.header.name_len > TCG_EVENT_NAME_LEN_MAX) {
+			printf("%d ERROR: event name too long!\n",
+			       template.header.name_len);
+			fclose(fp);
+			EVP_cleanup();
+			return 1;
+		}
+		memset(template.name, 0, sizeof(template.name));
+		byte_read = fread(template.name, template.header.name_len, 1, fp);
+		printf(" %s ", template.name);
+
+		if (read_template_data(&template, fp) < 0) {
+			RTLS_ERR("Reading of measurement entry failed\n");
+			break;
+		}
+
+		if (parse_template_data(&template) != 0) {
+			RTLS_ERR("Parsing of measurement entry failed\n");
+		}
+
+		if (verify) {
+			if (verify_template_hash(&template) != 0) {
+				hash_failed++;
+			}
+		}
+		printf("\n");
+		free(template.template_data);
+	}
+	fclose(fp);
+	EVP_cleanup();
+
+	printf("PCRAggr (re-calculated): ");
+	display_digest(pcr, SHA256_DIGEST_LENGTH);
+	printf("\n");
+
+	if (verify)	{
+		RTLS_INFO("Template hash verification: %s, failures is %d \n", !hash_failed ? "Success" : "Failed", hash_failed);
+	}
+
+	if (validate) {
+		ret = memcmp(pcr, data, datalen);
+		RTLS_INFO("Verifying if REM of cVM token matches reference value: %s \n",
+			(ret == 0) ? "Success" : "Failed");
+		if (ret != 0) {
+			return 1;
+		}
+	}
+
+	return 0;	
+}
\ No newline at end of file
diff --git a/samples/virtcca-client/inc/ima_measure.h b/samples/virtcca-client/inc/ima_measure.h
new file mode 100644
index 0000000..aeb5064
--- /dev/null
+++ b/samples/virtcca-client/inc/ima_measure.h
@@ -0,0 +1,17 @@
+#define TCG_EVENT_NAME_LEN_MAX	255
+#define IMA_TEMPLATE_FIELD_ID_MAX_LEN	16
+#define IMA_TEMPLATE_NUM_FIELDS_MAX	15
+#define CRYPTO_MAX_ALG_NAME 64
+
+#define IMA_TEMPLATE_IMA_NAME "ima"
+#define IMA_TEMPLATE_IMA_FMT "d|n"
+
+#define ARRAY_SIZE(arr) (sizeof(arr) / sizeof(arr[0]))
+
+#define ERROR_ENTRY_PARSING 1
+#define ERROR_FIELD_NOT_FOUND 2
+
+#define IMA_MEASUREMENTS_PATH "binary_runtime_measurements"
+
+
+int ima_measure(void *data, size_t datalen, int validate, int verify);
diff --git a/samples/virtcca-client/rats-client.c b/samples/virtcca-client/rats-client.c
new file mode 100644
index 0000000..0588464
--- /dev/null
+++ b/samples/virtcca-client/rats-client.c
@@ -0,0 +1,309 @@
+/* Copyright (c) 2021 Intel Corporation
+ * Copyright (c) 2020-2021 Alibaba Cloud
+ *
+ * SPDX-License-Identifier: Apache-2.0
+ */
+
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+#include <strings.h>
+#include <getopt.h>
+#include <sys/socket.h>
+#include <arpa/inet.h>
+#include <netinet/in.h>
+#include <unistd.h>
+#include <rats-tls/api.h>
+#include <rats-tls/log.h>
+#include <rats-tls/claim.h>
+#include "token_parse.h"
+#include "token_validate.h"
+#include "utils.h"
+#include "ima_measure.h"
+
+#define DEFAULT_PORT 1234
+#define DEFAULT_IP   "127.0.0.1"
+#define TOKEN "ATTESTATION_PASS"
+
+#define SHA256_SIZE 32
+#define SHA512_SIZE 64
+#define MAX_MEASUREMENT_SIZE SHA512_SIZE
+
+static uint8_t rim_ref[MAX_MEASUREMENT_SIZE];
+static size_t rim_ref_size = MAX_MEASUREMENT_SIZE;
+
+int user_callback(void *args)
+{
+	rtls_evidence_t *ev = (rtls_evidence_t *)args;
+	bool ret = true;
+	FILE *fp;
+	size_t byte_write;
+	int validate = 1;
+	int verify = 1;
+
+	cca_token_t token = {0};
+	cca_token_buf_t cca_token_buf = {0};
+	memcpy(&cca_token_buf, ev->cca.evidence, ev->cca.evidence_sz);
+	int i;
+	ret = parse_cca_attestation_token(&token, cca_token_buf.buf, cca_token_buf.buf_size);
+    if (ret != VIRTCCA_SUCCESS) {
+        RTLS_ERR("failed to parse virtcca token\n");
+        return ENCLAVE_VERIFIER_ERR_CBOR;
+    }
+
+	cert_info_t cert_info;
+	/* TODO: Read config files that includes certs path, rim, etc. */
+	strcpy(cert_info.cert_path_prefix, DEFAULT_CERT_PEM_PREFIX);
+    strcpy(cert_info.root_cert_filename, DEFAULT_ROOT_CERT_PEM_FILENAME);
+    strcpy(cert_info.sub_cert_filename, DEFAULT_SUB_CERT_PEM_FILENAME);
+    strcpy(cert_info.aik_cert_filename, DEFAULT_AIK_CERT_PEM_FILENAME);
+    strcpy(cert_info.root_cert_url, DEFAULT_ROOT_CERT_URL);
+    strcpy(cert_info.sub_cert_url, DEFAULT_SUB_CERT_URL);
+
+	ret = verify_cca_token_signatures(&cert_info,
+                                token.cvm_cose,
+                                token.cvm_token.pub_key,
+                                token.cvm_token.pub_key_hash_algo_id);
+	if (!ret) {
+        return false;
+    }
+
+	if (token.cvm_token.rim.len != rim_ref_size || 
+		memcmp(rim_ref, token.cvm_token.rim.ptr, token.cvm_token.rim.len)) {
+        printf("Verifying if RIM of cVM token matches reference value: Failed \n");
+		return false;
+    }
+
+	printf("verify_callback called, claims %p, claims_size %zu, args %p\n", ev->custom_claims,
+	       ev->custom_claims_length, args);
+	for (size_t i = 0; i < ev->custom_claims_length; ++i) {
+		printf("custom_claims[%zu] -> name: '%s' value_size: %zu value: '%.*s'\n", i,
+		       ev->custom_claims[i].name, ev->custom_claims[i].value_size,
+		       (int)ev->custom_claims[i].value_size, ev->custom_claims[i].value);
+		ret = (strcmp(ev->custom_claims[i].name, "ima") == 0);
+		if (ret) {
+			fp = fopen(IMA_MEASUREMENTS_PATH, "w");
+			byte_write = fwrite(ev->custom_claims[i].value, ev->custom_claims[i].value_size, 1, fp);
+			fclose(fp);
+			if (ima_measure((void *) token.cvm_token.rem[0].ptr, token.cvm_token.rem[0].len, validate, verify) != 0) {
+				return false;
+			}
+		}
+	}
+
+	return true;
+}
+
+int rats_tls_client_startup(rats_tls_log_level_t log_level, char *attester_type,
+			    char *verifier_type, char *tls_type, char *crypto_type, bool mutual,
+			    bool provide_endorsements, char *ip, int port)
+{
+	rats_tls_conf_t conf;
+
+	memset(&conf, 0, sizeof(conf));
+	conf.log_level = log_level;
+	strcpy(conf.attester_type, attester_type);
+	strcpy(conf.verifier_type, verifier_type);
+	strcpy(conf.tls_type, tls_type);
+	strcpy(conf.crypto_type, crypto_type);
+	conf.cert_algo = RATS_TLS_CERT_ALGO_DEFAULT;
+	if (mutual)
+		conf.flags |= RATS_TLS_CONF_FLAGS_MUTUAL;
+	if (provide_endorsements)
+		conf.flags |= RATS_TLS_CONF_FLAGS_PROVIDE_ENDORSEMENTS;
+
+	/* Create a socket that uses an internet IPv4 address,
+	 * Sets the socket to be stream based (TCP),
+	 * 0 means choose the default protocol.
+	 */
+	int sockfd = socket(AF_INET, SOCK_STREAM, 0);
+	if (sockfd < 0) {
+		RTLS_ERR("failed to call socket()\n");
+		return -1;
+	}
+
+	struct sockaddr_in s_addr;
+	memset(&s_addr, 0, sizeof(s_addr));
+	s_addr.sin_family = AF_INET;
+	s_addr.sin_port = htons(port);
+
+	/* Get the server IPv4 address from the command line call */
+	if (inet_pton(AF_INET, ip, &s_addr.sin_addr) != 1) {
+		RTLS_ERR("invalid server address\n");
+		return -1;
+	}
+
+	/* Connect to the server */
+	if (connect(sockfd, (struct sockaddr *)&s_addr, sizeof(s_addr)) == -1) {
+		RTLS_ERR("failed to call connect()\n");
+		return -1;
+	}
+
+	rats_tls_handle handle;
+	rats_tls_err_t ret = rats_tls_init(&conf, &handle);
+	if (ret != RATS_TLS_ERR_NONE) {
+		RTLS_ERR("Failed to initialize rats tls %#x\n", ret);
+		return -1;
+	}
+
+	ret = rats_tls_set_verification_callback(&handle, user_callback);
+	if (ret != RATS_TLS_ERR_NONE) {
+		RTLS_ERR("Failed to set verification callback %#x\n", ret);
+		return -1;
+	}
+
+	ret = rats_tls_negotiate(handle, sockfd);
+	if (ret != RATS_TLS_ERR_NONE) {
+		RTLS_ERR("Failed to negotiate %#x\n", ret);
+		goto err;
+	}
+
+	const char *msg = TOKEN;
+
+	size_t len = strlen(msg);
+	ret = rats_tls_transmit(handle, (void *)msg, &len);
+	if (ret != RATS_TLS_ERR_NONE || len != strlen(msg)) {
+		RTLS_ERR("Failed to transmit %#x\n", ret);
+		goto err;
+	}
+
+	char buf[1024];
+	len = sizeof(buf);
+	ret = rats_tls_receive(handle, buf, &len);
+	if (ret != RATS_TLS_ERR_NONE) {
+		RTLS_ERR("Failed to receive %#x\n", ret);
+		goto err;
+	}
+
+	if (len >= sizeof(buf))
+		len = sizeof(buf) - 1;
+	buf[len] = '\0';
+
+	/* Server not running in SGX Enlcave will only send hello message to client */
+	printf("Sent to Server: %s\n", msg);
+	printf("Received from Server: %s\n", buf);
+
+	shutdown(sockfd, SHUT_RDWR);
+	close(sockfd);
+	ret = rats_tls_cleanup(handle);
+	if (ret != RATS_TLS_ERR_NONE)
+		RTLS_ERR("Failed to cleanup %#x\n", ret);
+
+	return ret;
+
+err:
+	/* Ignore the error code of cleanup in order to return the prepositional error */
+	shutdown(sockfd, SHUT_RDWR);
+	close(sockfd);
+	rats_tls_cleanup(handle);
+
+	return -1;
+}
+
+int main(int argc, char **argv)
+{
+	char *const short_options = "a:v:t:c:mel:i:p:r:h";
+	// clang-format off
+	struct option long_options[] = {
+		{ "attester", required_argument, NULL, 'a' },
+		{ "verifier", required_argument, NULL, 'v' },
+		{ "tls", required_argument, NULL, 't' },
+		{ "crypto", required_argument, NULL, 'c' },
+		{ "mutual", no_argument, NULL, 'm' },
+		{ "endorsements", no_argument, NULL, 'e' },
+		{ "log-level", required_argument, NULL, 'l' },
+		{ "ip", required_argument, NULL, 'i' },
+		{ "port", required_argument, NULL, 'p' },
+		{ "rim", required_argument, NULL, 'r' },
+		{ "help", no_argument, NULL, 'h' },
+		{ 0, 0, 0, 0 }
+	};
+	// clang-format on
+
+	char *attester_type = "";
+	char *verifier_type = "";
+	char *tls_type = "";
+	char *crypto_type = "";
+	bool mutual = false;
+	bool provide_endorsements = false;
+	rats_tls_log_level_t log_level = RATS_TLS_LOG_LEVEL_INFO;
+	char *srv_ip = DEFAULT_IP;
+	int port = DEFAULT_PORT;
+	char *rim = "";
+	int opt;
+
+	do {
+		opt = getopt_long(argc, argv, short_options, long_options, NULL);
+		switch (opt) {
+		case 'a':
+			attester_type = optarg;
+			break;
+		case 'v':
+			verifier_type = optarg;
+			break;
+		case 't':
+			tls_type = optarg;
+			break;
+		case 'c':
+			crypto_type = optarg;
+			break;
+		case 'm':
+			mutual = true;
+			break;
+		case 'e':
+			provide_endorsements = true;
+			break;
+		case 'l':
+			if (!strcasecmp(optarg, "debug"))
+				log_level = RATS_TLS_LOG_LEVEL_DEBUG;
+			else if (!strcasecmp(optarg, "info"))
+				log_level = RATS_TLS_LOG_LEVEL_INFO;
+			else if (!strcasecmp(optarg, "warn"))
+				log_level = RATS_TLS_LOG_LEVEL_WARN;
+			else if (!strcasecmp(optarg, "error"))
+				log_level = RATS_TLS_LOG_LEVEL_ERROR;
+			else if (!strcasecmp(optarg, "fatal"))
+				log_level = RATS_TLS_LOG_LEVEL_FATAL;
+			else if (!strcasecmp(optarg, "off"))
+				log_level = RATS_TLS_LOG_LEVEL_NONE;
+			break;
+		case 'i':
+			srv_ip = optarg;
+			break;
+		case 'p':
+			port = atoi(optarg);
+			break;
+		case 'r':
+			rim = optarg;
+			if (hex_to_bytes(rim, strlen(rim), rim_ref, &rim_ref_size) != 0) {
+				exit(1);
+			}
+			break;
+		case -1:
+			break;
+		case 'h':
+			puts("    Usage:\n\n"
+			     "        rats-tls-client <options> [arguments]\n\n"
+			     "    Options:\n\n"
+			     "        --attester/-a value   set the type of quote attester\n"
+			     "        --verifier/-v value   set the type of quote verifier\n"
+			     "        --tls/-t value        set the type of tls wrapper\n"
+			     "        --crypto/-c value     set the type of crypto wrapper\n"
+			     "        --mutual/-m           set to enable mutual attestation\n"
+			     "        --endorsements/-e     set to let attester provide endorsements\n"
+			     "        --log-level/-l        set the log level\n"
+			     "        --ip/-i               set the listening ip address\n"
+			     "        --port/-p             set the listening tcp port\n"
+			     "        --rim/-r              set the initial measurement of cVM\n"
+			     "        --help/-h             show the usage\n");
+			exit(1);
+		default:
+			exit(1);
+		}
+	} while (opt != -1);
+
+	global_log_level = log_level;
+
+	return rats_tls_client_startup(log_level, attester_type, verifier_type, tls_type,
+				       crypto_type, mutual, provide_endorsements, srv_ip, port);
+}
diff --git a/samples/virtcca-client/utils/CMakeLists.txt b/samples/virtcca-client/utils/CMakeLists.txt
new file mode 100644
index 0000000..84d6b47
--- /dev/null
+++ b/samples/virtcca-client/utils/CMakeLists.txt
@@ -0,0 +1,19 @@
+cmake_minimum_required(VERSION 3.12)
+project(utils
+        DESCRIPTION "utils"
+        LANGUAGES C)
+ 
+# Built-in CMake options
+set(BUILD_SHARED_LIBS OFF CACHE BOOL "Create shared instead of static libraries")
+
+if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
+    message(STATUS "No build type selected, defaulting to Release")
+    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type" FORCE)
+endif()
+
+set(UTILS_SRC_COMMON
+    src/utils.c
+)
+
+add_library(${PROJECT_NAME} STATIC ${UTILS_SRC_COMMON})
+target_include_directories(${PROJECT_NAME} PUBLIC inc PRIVATE src)
\ No newline at end of file
diff --git a/samples/virtcca-server/CMakeLists.txt b/samples/virtcca-server/CMakeLists.txt
new file mode 100644
index 0000000..12b2ede
--- /dev/null
+++ b/samples/virtcca-server/CMakeLists.txt
@@ -0,0 +1,25 @@
+# Project name
+project(virtcca-server)
+
+set(CMAKE_C_FLAGS "-fPIE ${CMAKE_C_FLAGS}")
+
+set(INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../../src/include
+                    ${CMAKE_CURRENT_SOURCE_DIR}/../../src/include/edl
+                    ${CMAKE_CURRENT_SOURCE_DIR}/../../src/include/rats-tls
+                    ${RATS_TLS_INSTALL_INCLUDE_PATH}
+                    ${RATS_TLS_INSTALL_INCLUDE_PATH}/edl
+                    )
+set(LIBRARY_DIRS ${RATS_TLS_INSTALL_LIB_PATH})
+
+include_directories(${INCLUDE_DIRS})
+link_directories(${LIBRARY_DIRS})
+
+# Set source file
+set(SOURCES rats-server.c)
+
+# Generate bin file
+add_executable(${PROJECT_NAME} ${SOURCES})
+target_link_libraries(${PROJECT_NAME} rats_tls)
+
+install(TARGETS ${PROJECT_NAME}
+	    DESTINATION ${RATS_TLS_INSTALL_BIN_PATH})
